/* EPITA S3 2014/2015         */
/* Controle 1 - November 2014 */
/* question01                 */

#define QNUM 1
#define QOPT "graine taille"
#define QNOPT 2

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include "base_test.h"
#include "question01.h"

void fixed_test(size_t len) {
  printf("Fixed tests:\n");
  for (unsigned long i = 0; i < len; ++i) {
    printf("  power( 2, %2lu) = %20lu (expected %lu)\n", i, power(2,i), (unsigned long)1 << i);
  }
}

void random_test(size_t len) {
  printf("Random tests:\n");
  for (unsigned long i = 0; i < len; ++i) {
    unsigned long       a, b;
    a = 2 + random() % 8;
    b = random() % 20;
    printf("  power( %lu, %2lu) = %20lu\n", a, b, power(a,b));
  }
}


int main(int argc,char *argv[])
{
  size_t        size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT)
    {
      fprintf(stderr, "Parametres insuffisants.\n");
      usage(NULL,QNUM,QOPT);
    }
  else
    {
      seedInit(argv);
      size = getSize(argv);
      fixed_test(size);
      random_test(size);
    }
  exit(0);
}
