/* EPITA S3 2014/2015         */
/* Controle 1 - November 2014 */
/* question04                 */

#define QNUM 4
#define QOPT "graine taille"
#define QNOPT 2

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include "base_test.h"
#include "question04.h"

void bitprint(unsigned x) {
  char          buf[1 + 8 * sizeof (unsigned)];
  buf[8 * sizeof (unsigned)] = 0;
  for (unsigned i = 0; i < 8 * sizeof (unsigned); ++i)
    buf[i] = '0';
  for (unsigned i = 8 * sizeof (unsigned) - 1; x > 0; x >>= 1, --i) {
    buf[i] = '0' + (x % 2);
  }
  printf("%s", buf);
}

void fixed_test(void) {
  printf("Fixed Tests:\n");
  unsigned      a, b;
  a = 0;
  b = a - 1;
  printf("a = "); bitprint(a);
  printf("\n");
  printf("b = "); bitprint(b);
  printf("\n");
  printf("hamming(a, b) = %u\n", hamming(a, b));
}

void random_test(size_t len) {
  printf("Random Tests:\n");
  for (size_t i = 0; i < len; ++i) {
    unsigned    a, b;
    a = (unsigned)random();
    b = (unsigned)random();
    printf("a = "); bitprint(a);
    printf("\n");
    printf("b = "); bitprint(b);
    printf("\n");
    printf("hamming(a, b) = %u\n", hamming(a, b));
  }
}

int main(int argc,char *argv[]) {
  size_t        size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT) {
    fprintf(stderr, "Parametres insuffisants.\n");
    usage(NULL,QNUM,QOPT);
  } else {
    seedInit(argv);
    size = getSize(argv);
    fixed_test();
    random_test(size);
  }
  exit(0);
}
