/* EPITA S3 2014/2015         */
/* Controle 1 - November 2014 */
/* question06                 */

#define QNUM 6
#define QOPT "graine taille"
#define QNOPT 2

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include "base_test.h"
#include "question06.h"

static
void fixed_test() {
  printf("FIXED TESTS:\n");
  char          s[] = "A FULL UPPER-CASE STRING.AA";
  size_t        n = sizeof (s) - 3;
  s[n] = 0;
  printf("Original:\n  \"%s\"\n", s);
  to_lower(s);
  printf("After to lower:\n  \"%s\"\n", s);
  printf("Off-bound check: %s %s\n",
         check(s[n] == 0), check(s[n+1] == 'A'));
}

static
void rand_test(size_t n) {
  if (n) {
    printf("RANDOM TESTS:\n");
    char       *s;
    s = calloc(n + 2,1);
    randstr(s,n);
    s[n+1] = 'A';
    printf("Original:\n  \"%s\"\n", s);
    to_lower(s);
    printf("After to lower:\n  \"%s\"\n", s);
    printf("Off-bound check: %s %s\n",
           check(s[n] == 0), check(s[n+1] == 'A'));
  }
}

int main(int argc,char *argv[]) {
  size_t                size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT) {
    fprintf(stderr, "Parametres insuffisants.\n");
    usage(NULL,QNUM,QOPT);
  } else {
    seedInit(argv);
    size = getSize(argv);
    fixed_test();
    rand_test(size);
  }
  exit(0);
}
