/* EPITA S3 2014/2015         */
/* Controle 1 - November 2014 */
/* question09                 */

#define QNUM 9
#define QOPT "taille"
#define QNOPT 1

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include "base_test.h"
#include "question09.h"

typedef struct s_list  *list;

static
void print_list(char *pref, list l) {
  size_t                line = 2;
  if (!pref) pref = (char*)"l";
  printf("%s =%s\n",pref,(l?"":" EMPTY"));
  if (l) {
    printf("  ");
    goto inside;
    for (; l; l = l->next) {
      line += (unsigned)printf(" -> ");
    inside:
      line += (unsigned)printf("%02d", l->val);
      if (line > 72)
        line = (unsigned)printf("\n    ");
    }
    printf("\n");
  }
}

static
struct s_list *add(struct s_list *l, int x) {
  struct s_list        *tmp;
  tmp = malloc(sizeof (struct s_list));
  tmp->val = x;
  tmp->next = l;
  return tmp;
}

static
void erase(struct s_list *l) {
  while (l) {
    struct s_list      *t = l;
    l = l->next;
    t->next = (void*)0xd0d0d0d0;
    t->val  = -1;
    free(t);
  }
}

static
struct s_list *build_test_list(size_t s) {
  struct s_list        *l = NULL;
  for (long i = (long)(s - 1); i >= 0; --i)
    l = add(l, (int)i);
  return l;
}

int main(int argc,char *argv[]) {
  size_t                size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT) {
    fprintf(stderr, "Parametres insuffisants.\n");
    usage(NULL,QNUM,QOPT);
  }
  else {
    struct s_list      *l, *rl;
    size = strtoull(argv[1], NULL, 10);
    l = build_test_list(size);
    print_list(NULL, l);
    printf("Cloning list ... ");
    printf("rl = duplicate_list(l)\n");
    rl = duplicate_list(l);
    printf("Delete (free) l ... \n");
    erase(l);
    print_list("rl", rl);
  }
  exit(0);
}
