/* EPITA S3 2014/2015         */
/* Controle 1 - November 2014 */
/* question10                 */

# define QNUM 10
# define QOPT "taille"
# define QNOPT 1


# include <unistd.h>
# include <stdlib.h>
# include <stdio.h>
# include "base_test.h"
# include "question10.h"

static
void print_list(char *pref, struct list *l) {
  size_t                line = 2;
  if (!pref) pref = (char*)"l";
  printf("%s =%s\n",pref,(l?"":" EMPTY"));
  if (l) {
    printf("  ");
    goto inside;
    for (; l; l = l->next) {
      line += printf(" -> ");
    inside:
      line += printf("%02d", l->val);
      if (line > 72)
        line = printf("\n    ");
    }
    printf("\n");
  }
}

void build_sorted(size_t len, struct list **odd, struct list **even) {
  struct list          *store;
  store = calloc(2 * len, sizeof (struct list));
  for (size_t i = 0; i < 2 * len; ++i) {
    store[i].val = (int)i;
    store[i].next = i + 2 < 2 * len ? store + i + 2 : NULL;
  }
  *odd = store + 1;
  *even = store;
}

static
void tests(size_t len) {
  if (len == 0) {
    printf("Empty size is useless ...\n");
    return;
  }
  struct list          *l1, *l2;
  build_sorted(len, &l1, &l2);
  print_list("l1", l1);
  print_list("l2", l2);
  struct list          *l;
  l = merge(l1, l2);
  printf("l = merge(l1, l2)\n");
  print_list("l", l);
}

int main(int argc,char *argv[]) {
  size_t                size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT) {
    fprintf(stderr, "Parametres insuffisants.\n");
    usage(NULL,QNUM,QOPT);
  }
  else {
    size = strtoul(argv[1], NULL, 10);
    tests(size);
  }
  exit(0);
}
