/* EPITA S3 2014/2015         */
/* Controle 1 - November 2014 */
/* question                 */

#define QNUM 12
#define QOPT "graine taille"
#define QNOPT 2

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include "base_test.h"
#include "question12.h"

static inline
char printable(uint8_t c) {
  return c < 33 || c > 126 ? ' ' : c;
}

static inline
void printnozero(size_t c) {
  if (c)
    printf("%4zu ", c);
  else
    printf("     ");
}

static
void print_count(size_t counts[]) {
  size_t                sum = 0;
  for (uint8_t i=0; i < 32; ++i) {
    printf("| 0x%02hhx %c : ", i, printable(i));
    printnozero(counts[i]);
    sum += counts[i];
    uint8_t j = i+32;
    printf("| 0x%02hhx %c : ", j, printable(j));
    printnozero(counts[j]);
    sum += counts[j];
    j += 32;
    printf("| 0x%02hhx %c : ", j, printable(j));
    printnozero(counts[j]);
    sum += counts[j];
    j += 32;
    printf("| 0x%02hhx %c :", j, printable(j));
    sum += counts[j];
    printnozero(counts[j]);
    printf("|\n");
  }
  printf("Total count: %zu\n", sum);
}

static
void rand_test(size_t size) {
  char         *s;
  size_t        counts[256];
  s = malloc(size+1);
  randstr(s,size);
  s[size] = 0;
  printf("s = \"%s\"\n",s);
  printf("hist(s, %zu, counts)\n", size);
  hist(s, size, counts);
  print_count(counts);
}

int main(int argc,char *argv[]) {
  size_t                size;

  help_asked(argc,argv,QNUM,QOPT,QNOPT);

  if (argc <= QNOPT) {
    fprintf(stderr, "Parametres insuffisants.\n");
    usage(NULL,QNUM,QOPT);
  } else {
    seedInit(argv);
    size = getSize(argv);
    rand_test(size);
  }
  exit(0);
}
